DlgProc proc uses ebx esi edi hWnd,uMsg,wParam,lParam
	mov eax,uMsg
WM_CASE eax,<CLOSE,INITDIALOG,COMMAND,HEXUPDATE>
@r0:	xor eax,eax
@r:	ret
@@CLOSE:
	invoke EndDialog,hWnd,eax
	jmp @r
@@INITDIALOG:
BlockStart 	;      
	invoke GetDlgItem,hWnd,10
	xchg eax,ebx
	invoke SetWindowText,ebx,offset HexBytes
	invoke SetWindowLong,ebx,GWL_WNDPROC,offset HexEdit
	mov ERealProc,eax
	invoke GetStockObject,OEM_FIXED_FONT
	mov edi,eax
	invoke SendMessage,ebx,WM_SETFONT,eax,1
BlockEnd	;EDI = OEMFONT,EBX=HexEdit hwnd.

BlockStart	;return 1
	push 1
	pop eax
	jmp @r
BlockEnd
@@HEXUPDATE:

	invoke GetDlgItemText,hWnd,10,offset HexBytes,12
	invoke SepHexToBytes,offset HexBytes,offset DiplacementByte
	jmp @Decode
@@COMMAND:

BlockStart	;if wParam = 2 (esc) -> exit
	mov ebx,wParam
	cmp ebx,2
	je @@CLOSE
BlockEnd	;ebx = wParam

BlockStart	;determin if ebx is in range of [11-30],set bits
	sub ebx,11 ;ebx 0 base = 11
	cmp ebx,20 ;ebx>=32?
	jnc @r
	btc dword ptr modrm,ebx ;set bit
BlockEnd 	;ebx - index of bit from modrm start

BlockStart  ;if index = w bit button -> change 0\1 text
 	cmp ebx,27-11
	ja @F
	push eax
	mov eax,esp
	invoke GetDlgItemText,hWnd,wParam,eax,2
	xor byte ptr [esp],1
	invoke SetDlgItemText,hWnd,wParam,esp
	pop eax
BlockEnd	;eax = 1
@Decode:
@@:
BlockStart ;;      
	movzx eax,flags
	mov edi,offset opcode
	mov cl,modrm
	push edi ;save offset opcode
	mov [edi],cl ;copy modr/m
	inc edi	;set pointer to the next to modr/m byte
	bt eax,3	;check for 32 bit flag
	jc @F		;flag is set not need to change 67,66 flag
;16 bit mode - invert 67,66
	xor al,0110b
@@:
	test al,100b ;if 67h?
	je @32bitMode ;no -> go to 16bit mode
;16 bit address mode---cl=modrm---------
		cmp cl,0C0h ;if only regs
		jnc @endmov ;only regs
		;modrm <> 11 if it's 00?
		cmp cl,40h ;<1?
		jnc @writedisp ;mod = 01 or 10
			;mod = 0 memr=110?
			and cl,0111b ;mask memr
			cmp cl,0110b ;only disp?
			je @writedisp ;yes
		jmp @endmov ;no
@32bitMode:
		cmp cl,0C0h ;if mod = 11
		jnc @endmov ;YES - end transfer
	;if SIB
		mov ch,cl ;duplicate modr/m
		and ch,111b ;mask m/r
		cmp ch,100b ;SIB?
		jne @nosib
	;YES
		mov dl,sib
		mov [edi],dl
		inc edi
	;if displacement
		cmp cl,40h ;if mod < 01(i.e. = 0)
		jnc @writedisp ; no - then there is displacement
	;if mod=0 and memr=101 then also disp
		mov ch,sib
		and ch,111b
		cmp ch,101b
		jne @endmov
		jmp @writedisp		 	
	@nosib:
		cmp cl,40h ;if mod < 01(i.e. = 0)
		jnc @writedisp
		;mod = 0 ; what about memr=101?
		and cl,111b
		cmp cl,101b
		jne @endmov ;mod = 0 but memr <> 101
@writedisp:
		mov edx,DiplacementByte
		mov [edi],edx
@endmov:
		pop esi	;offset opcode bytes -> esi
BlockEnd	;eax = flags, esi= offset of opcode bytes
	mov esi,offset opcode
	mov edi,offset mnemonic
	pushr 7
	invoke DecMemr,eax
	mov byte ptr [edi],0
	popr 7
	invoke SetDlgItemText,hWnd,31,edi
	jmp @r
DlgProc endp